<?php
/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link  mailto:'contact@tillpaid.com'
 * @since 4.0.1
 *
 * @package    Cash_To_Cash_Payments_For_Woocommerce
 * @subpackage Cash_To_Cash_Payments_For_Woocommerce/includes
 */

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      4.0.1
 * @package    Cash_To_Cash_Payments_For_Woocommerce
 * @subpackage Cash_To_Cash_Payments_For_Woocommerce/includes
 * @author     Tillpaid <hello@tillpaid.com>
 */
class Cash_To_Cash_Payments_For_Woocommerce {


	/**
	 * The loader that's responsible for maintaining and registering all hooks that power
	 * the plugin.
	 *
	 * @since  4.0.1
	 * @access protected
	 * @var    Cash_To_Cash_Payments_For_Woocommerce_loader    $loader    Maintains and registers all hooks for the plugin.
	 */
	protected $loader;

	/**
	 * The unique identifier of this plugin.
	 *
	 * @since  4.0.1
	 * @access protected
	 * @var    string    $plugin_name    The string used to uniquely identify this plugin.
	 */
	protected $plugin_name;

	/**
	 * The current version of the plugin.
	 *
	 * @since  4.0.1
	 * @access protected
	 * @var    string    $version    The current version of the plugin.
	 */
	protected $version;

	/**
	 * Define the core functionality of the plugin.
	 *
	 * Set the plugin name and the plugin version that can be used throughout the plugin.
	 * Load the dependencies, define the locale, and set the hooks for the admin area and
	 * the public-facing side of the site.
	 *
	 * @since 4.0.1
	 */
	public function __construct() {
		if ( defined( 'Cash_To_Cash_Payments_For_Woocommerce_VERSION' ) ) {
			$this->version = Cash_To_Cash_Payments_For_Woocommerce_VERSION;
		} else {
			$this->version = '4.0.1';
		}
		$this->plugin_name = 'cash-to-cash-payments-for-woocommerce';

		$this->load_dependencies();
		$this->set_locale();
		$this->define_admin_hooks();
		$this->define_public_hooks();
	}

	/**
	 * Load the required dependencies for this plugin.
	 *
	 * Include the following files that make up the plugin:
	 *
	 * - Cash_To_Cash_Payments_For_Woocommerce_loader. Orchestrates the hooks of the plugin.
	 * - Cash_To_Cash_Payments_For_Woocommerce_i18n. Defines internationalization functionality.
	 * - Cash_To_Cash_Payments_For_Woocommerce_admin. Defines all hooks for the admin area.
	 * - Cash_To_Cash_Payments_For_Woocommerce_public. Defines all hooks for the public side of the site.
	 *
	 * Create an instance of the loader which will be used to register the hooks
	 * with WordPress.
	 *
	 * @since  4.0.1
	 * @access private
	 */
	private function load_dependencies() {

		/**
		 * The class responsible for orchestrating the actions and filters of the
		 * core plugin.
		 */
		include_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-cash-to-cash-payments-for-woocommerce-loader.php';

		/**
		 * The class responsible for defining internationalization functionality
		 * of the plugin.
		 */
		include_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-cash-to-cash-payments-for-woocommerce-i18n.php';

		/**
		 * The class responsible for defining all actions that occur in the admin area.
		 */
		include_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/class-cash-to-cash-payments-for-woocommerce-admin.php';

		/**
		 * The class responsible for defining all actions that occur in the public-facing
		 * side of the site.
		 */
		include_once plugin_dir_path( dirname( __FILE__ ) ) . 'public/class-cash-to-cash-payments-for-woocommerce-public.php';

		/**
		 * The class responsible to display Cash to Cash Payments For Woocommerce Payment Gateway in dashboard
		 */
		include_once plugin_dir_path( dirname( __FILE__ ) ) . 'payment-gateway/class-cash-to-cash-payments-for-woocommerce-payment-gateway.php';

		$this->loader = new Cash_To_Cash_Payments_For_Woocommerce_loader();
	}

	/**
	 * Define the locale for this plugin for internationalization.
	 *
	 * Uses the Cash_To_Cash_Payments_For_Woocommerce_i18n class in order to set the domain and to register the hook
	 * with WordPress.
	 *
	 * @since  4.0.1
	 * @access private
	 */
	private function set_locale() {

		$plugin_i18n = new Cash_To_Cash_Payments_For_Woocommerce_i18n();

		$this->loader->add_action( 'plugins_loaded', $plugin_i18n, 'load_plugin_textdomain' );
	}

	/**
	 * Register all of the hooks related to the admin area functionality
	 * of the plugin.
	 *
	 * @since  4.0.1
	 * @access private
	 */
	private function define_admin_hooks() {

		$plugin_admin = new Cash_To_Cash_Payments_For_Woocommerce_admin( $this->get_plugin_name(), $this->get_version() );

		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_styles' );
		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts' );
		$this->loader->add_action( 'admin_notices', $plugin_admin, 'check_if_woocommerce_is_active' );
		$this->loader->add_filter( 'plugin_action_links', $plugin_admin, 'link_to_settings',10,2 );
		
	}

	/**
	 * Register all of the hooks related to the public-facing functionality
	 * of the plugin.
	 *
	 * @since  4.0.1
	 * @access private
	 */
	private function define_public_hooks() {

		$plugin_public = new Cash_To_Cash_Payments_For_Woocommerce_public( $this->get_plugin_name(), $this->get_version() );

		$this->loader->add_action( 'wp_enqueue_scripts', $plugin_public, 'enqueue_styles' );
		$this->loader->add_action( 'wp_enqueue_scripts', $plugin_public, 'enqueue_scripts' );
	}

	/**
	 * Run the loader to execute all of the hooks with WordPress.
	 *
	 * @since 4.0.1
	 */
	public function run() {
		$this->loader->run();
	}

	/**
	 * The name of the plugin used to uniquely identify it within the context of
	 * WordPress and to define internationalization functionality.
	 *
	 * @since  4.0.1
	 * @return string    The name of the plugin.
	 */
	public function get_plugin_name() {
		return $this->plugin_name;
	}

	/**
	 * The reference to the class that orchestrates the hooks with the plugin.
	 *
	 * @since  4.0.1
	 * @return Cash_To_Cash_Payments_For_Woocommerce_loader    Orchestrates the hooks of the plugin.
	 */
	public function get_loader() {
		return $this->loader;
	}

	/**
	 * Retrieve the version number of the plugin.
	 *
	 * @since  4.0.1
	 * @return string    The version number of the plugin.
	 */
	public function get_version() {
		return $this->version;
	}

}
